<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: DayzExpansion/Vehicles/Scripts/4_world/dayzexpansion_vehicles/entities/players/cameras/deprecated/dayzplayercamera1stperson.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.12</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('da/d80/a09102_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">dayzplayercamera1stperson.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../da/d80/a09102.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * DayZPlayerCamera1stPerson.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * DayZ Expansion Mod</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * www.dayzexpansion.com</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * © 2022 DayZ Expansion Mod Team</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License.</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-nd/4.0/.</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#ifdef EXPANSION_OBSOLETE_CAMERA</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>modded <span class="keyword">class </span><a class="code hl_class" href="../../d9/d55/a07425.html">DayZPlayerCamera1stPerson</a></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>{   </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../da/d8e/a02759.html#a2caf1c030cd197f2ba53cffa0d5b9237">OnUpdate</a>( <span class="keywordtype">float</span> pDt, out DayZPlayerCameraResult pOutResult )</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>    {</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#ifdef EXPANSIONTRACE</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>        <span class="keyword">auto</span> trace = <a class="code hl_function" href="../../d4/deb/a00710.html#a2dbd0d5f5331e4721875b123084eb0df">CF_Trace_1</a>(ExpansionTracing.VEHICLES, <span class="keyword">this</span>, <span class="stringliteral">&quot;OnUpdate&quot;</span>).Add(pDt);</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>        super.OnUpdate( pDt, pOutResult );</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>        </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>        pOutResult.m_fInsideCamera = 1.0;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>        <a class="code hl_class" href="../../d8/d3b/a07441.html">ExpansionVehicleBase</a> vehicle;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>        <a class="code hl_class" href="../../d0/d2a/a04925.html">CarScript</a> car;</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>        Class.CastTo( car, m_pPlayer.GetParent() );</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span> </div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>        <a class="code hl_class" href="../../db/d1a/a03849.html">PlayerBase</a> m_pbPlayer = <a class="code hl_class" href="../../db/d1a/a03849.html">PlayerBase</a>.Cast( m_pPlayer );</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>        </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>        <span class="keywordflow">if</span> ( Class.CastTo( vehicle, m_pPlayer.GetParent() ) || m_pbPlayer.IsAttached() )</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>        {</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>            pOutResult.m_fInsideCamera = 0.0;</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>            </div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>            m_pbPlayer.SetHeadInvisible_Ex( <span class="keyword">true</span> );</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>        } <span class="keywordflow">else</span></div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>        {           </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>            pOutResult.m_fInsideCamera = 1.0;</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>            </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>            GetGame().GetCallQueue( CALL_CATEGORY_GAMEPLAY).Call( m_pbPlayer.SetHeadInvisible_Ex, <span class="keyword">false</span> );</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>        }</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>        </div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>        <span class="keywordflow">if</span> ( m_pPlayer.GetCommand_Vehicle() || m_pbPlayer.GetCommand_ExpansionVehicle() )</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>        {</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>        }</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span> </div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>        pOutResult.m_bUpdateWhenBlendOut = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>        pOutResult.m_fIgnoreParentRoll = 0;</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>        pOutResult.m_iDirectBone = -1;</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>        pOutResult.m_iDirectBoneMode = 3;</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        pOutResult.m_fPositionModelSpace = 0.0;</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>        pOutResult.m_fUseHeading = 0;</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>        </div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        vector rot;</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>        </div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>        HumanInputController input = m_pPlayer.GetInputController();</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>        <span class="keywordtype">float</span> heading = input.GetHeadingAngle() * Math.RAD2DEG;</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>        </div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>        <span class="keywordflow">if</span> (vehicle)</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>        {</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>            heading -= vehicle.GetOrientation()[0];</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        }</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>        </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>        <span class="keywordflow">if</span> (car)</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>        {</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>            heading -= car.GetOrientation()[0];</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>        }</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span> </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>        rot[0] = m_fLeftRightAngle - heading;</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>        rot[1] = m_CurrentCameraPitch;</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>        rot[2] = 0;</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>            </div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>        vector cameraTransform[4];</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>        Math3D.YawPitchRollMatrix(rot, cameraTransform);</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>        cameraTransform[3] = m_pPlayer.GetBonePositionWS(m_iBoneIndex);</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>            </div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        vector playerTransform[4];</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>        m_pPlayer.GetTransform(playerTransform);</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>            </div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>        Math3D.MatrixInvMultiply4(playerTransform, cameraTransform, pOutResult.m_CameraTM);</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>        </div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        pOutResult.m_CameraTM[3] = pOutResult.m_CameraTM[3] + m_OffsetLS;   </div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>    }</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>};</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span><span class="preprocessor">#endif</span></div>
<div class="ttc" id="aa00710_html_a2dbd0d5f5331e4721875b123084eb0df"><div class="ttname"><a href="../../d4/deb/a00710.html#a2dbd0d5f5331e4721875b123084eb0df">CF_Trace_1</a></div><div class="ttdeci">static CF_Trace CF_Trace_1(bool doLog, Class instance)</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/deb/a00710_source.html#l00075">cf_trace.c:75</a></div></div>
<div class="ttc" id="aa02759_html_a2caf1c030cd197f2ba53cffa0d5b9237"><div class="ttname"><a href="../../da/d8e/a02759.html#a2caf1c030cd197f2ba53cffa0d5b9237">OnUpdate</a></div><div class="ttdeci">override void OnUpdate(ActionData action_data)</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d8e/a02759_source.html#l00148">expansionactiongetoutexpansionvehicle.c:148</a></div></div>
<div class="ttc" id="aa03849_html"><div class="ttname"><a href="../../db/d1a/a03849.html">PlayerBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d2/d25/a08607_source.html#l00013">playerbase.c:14</a></div></div>
<div class="ttc" id="aa04925_html"><div class="ttname"><a href="../../d0/d2a/a04925.html">CarScript</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d5/da8/a08961_source.html#l00016">carscript.c:17</a></div></div>
<div class="ttc" id="aa07425_html"><div class="ttname"><a href="../../d9/d55/a07425.html">DayZPlayerCamera1stPerson</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d1/d24/a02975_source.html#l00014">dayzplayercamera1stperson.c:15</a></div></div>
<div class="ttc" id="aa07441_html"><div class="ttname"><a href="../../d8/d3b/a07441.html">ExpansionVehicleBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d8b/a02996_source.html#l00017">expansionvehiclebikebase.c:18</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_6127fff2da0a20e2dc2cd9302c584350.html">DayzExpansion</a></li><li class="navelem"><a class="el" href="../../dir_403148263ee4e8f0781f7c219c37e738.html">Vehicles</a></li><li class="navelem"><a class="el" href="../../dir_73552948bc6e6c947ae98efa6ef1fc72.html">Scripts</a></li><li class="navelem"><a class="el" href="../../dir_c3648096b79390b8f298110e534a6ba9.html">4_world</a></li><li class="navelem"><a class="el" href="../../dir_0df2f0f75bfab0aa29ae62af7848909b.html">dayzexpansion_vehicles</a></li><li class="navelem"><a class="el" href="../../dir_b27e8102d55cc5d44e37d1ed7930554c.html">entities</a></li><li class="navelem"><a class="el" href="../../dir_dfc29380485db2d9a9e4f35b67d520fb.html">players</a></li><li class="navelem"><a class="el" href="../../dir_e58a1f627c335b77fbfd53e03d9f36c4.html">cameras</a></li><li class="navelem"><a class="el" href="../../dir_8834dbe6b28a069e5e0eb358d4220f90.html">deprecated</a></li><li class="navelem"><a class="el" href="../../da/d80/a09102.html">dayzplayercamera1stperson.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
